{{- $envVars := include "common.env.transformDict" .Values.envVars -}}
{{- $fullName := include "common.fullname" . -}}
{{- $serviceAccountName := include "common.serviceAccountName" . -}}
{{- range .Values.jobs.cron }}
---
{{- if .frequency -}}
apiVersion: batch/v1
kind: CronJob
metadata:
  name: "{{ $fullName }}{{ .suffix }}"
  labels:
  {{- include "common.labels" $ | nindent 4 }}
spec:
  schedule: "{{ .frequency }}"
  jobTemplate:
    spec:
      template:
        spec:
          {{- if $.Values.image.credentials }}
          imagePullSecrets:
            - name: {{ include "common.secret.dockerconfigjson.name" (dict "fullname" $fullName "imageCredentials" $.Values.image.credentials) }}
          {{- end }}
          serviceAccountName: {{ $serviceAccountName }}
          containers:
            - name: "{{ $.Chart.Name }}{{ .suffix }}"
              image: "{{ $.Values.image.repository }}:{{ $.Values.image.tag | default $.Chart.AppVersion }}"
              imagePullPolicy: {{ $.Values.image.pullPolicy }}
              {{- if $envVars}}
              env:
                {{- $envVars | nindent 16 }}
              {{- end }}
              args:
                {{- range .args }}
                - {{ . | quote }}
                {{- end }}
              resources:
                {{- toYaml $.Values.resources | nindent 16 }}
          restartPolicy: OnFailure
          {{- with $.Values.nodeSelector }}
          nodeSelector:
            {{- toYaml . | nindent 12 }}
          {{- end }}
          {{- with $.Values.affinity }}
          affinity:
            {{- toYaml . | nindent 12 }}
          {{- end }}
          {{- with $.Values.tolerations }}
          tolerations:
            {{- toYaml . | nindent 12 }}
          {{- end }}
{{- end -}}
{{- end -}}
